'From Squeak3.4gamma of ''7 January 2003'' [latest update: #5169] on 25 March 2003 at 12:51:48 am'!
"Change Set:		BasicEnh-ajh
Date:			24 March 2003
Author:			Anthony Hannan

This adds some simple methods to basic objects and adds a nicer CompiledMethod inspector and a new subclass of ProtoObject called BasicObject which implements some key methods such as instVarAt:, so things won't break if not forwarded to something.  This also adds several helpful but general methods to collections and streams, and a couple of new collection classes: KeyedSet and KeyedIdentitySet.  They are like dictionaries except values are the elements themselves (not associations) and are responsible for responding to #key.

This must be filed-in before ContextEnh-ajh (and PreContextEnh-ajh)."!

ProtoObject subclass: #BasicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!BasicObject commentStamp: 'ajh 1/27/2003 20:03' prior: 0!
I am like ProtoObject except I implement some basic Object protocol that is needed for basic operations without breaking, but does not include all the other Object behavior.!

Inspector subclass: #BasicInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Inspector'!
Inspector subclass: #CompiledMethodInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Inspector'!
Set subclass: #KeyedSet
	instanceVariableNames: 'keyBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Unordered'!

!KeyedSet commentStamp: '<historical>' prior: 0!
Like Set except a key of every element is used for hashing and searching instead of the element itself.  keyBlock gets the key of an element.!

KeyedSet subclass: #KeyedIdentitySet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Unordered'!

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive: arg1
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive: arg1 with: arg2
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive: arg1 with: arg2 with: arg3
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7 with: arg8
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryPrimitive: primIndex withArgs: argumentArray
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."

	<primitive: 118>
	^ ContextPart primitiveFailToken! !


!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/22/2003 22:28'!
basicAt: index 
	"Primitive. Assumes receiver is indexable. Answer the value of an 
	indexable element in the receiver. Fail if the argument index is not an 
	Integer or is out of bounds. Essential. Do not override in a subclass. See 
	Object documentation whatIsAPrimitive."

	<primitive: 60>
	index isInteger ifTrue: [self errorSubscriptBounds: index].
	index isNumber
		ifTrue: [^self basicAt: index asInteger]
		ifFalse: [self errorNonIntegerIndex]! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/22/2003 22:28'!
basicAt: index put: value 
	"Primitive. Assumes receiver is indexable. Store the second argument 
	value in the indexable element of the receiver indicated by index. Fail 
	if the index is not an Integer or is out of bounds. Or fail if the value is 
	not of the right type for this kind of collection. Answer the value that 
	was stored. Essential. Do not override in a subclass. See Object 
	documentation whatIsAPrimitive."

	<primitive: 61>
	index isInteger
		ifTrue: [(index >= 1 and: [index <= self size])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]].
	index isNumber
		ifTrue: [^self basicAt: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/22/2003 22:26'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/22/2003 22:27'!
instVarAt: index 
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 73>
	"Access beyond fixed variables."
	^self basicAt: index - self class instSize		! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/22/2003 22:27'!
instVarAt: anInteger put: anObject 
	"Primitive. Store a value into a fixed variable in the receiver. The 
	numbering of the variables corresponds to the named instance variables. 
	Fail if the index is not an Integer or is not the index of a fixed variable. 
	Answer the value stored as the result. Using this message violates the 
	principle that each object has sovereign control over the storing of 
	values into its instance variables. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 74>
	"Access beyond fixed fields"
	^self basicAt: anInteger - self class instSize put: anObject! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/22/2003 22:34'!
isBehavior
	"Return true if the receiver is a behavior.
	Note: Do not override in any class except behavior."
	^false! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/22/2003 22:26'!
isKindOf: aClass 
	"Answer whether the class, aClass, is a superclass or class of the receiver."

	self class == aClass
		ifTrue: [^true]
		ifFalse: [^self class inheritsFrom: aClass]! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/23/2003 00:28'!
isMemberOf: aClass 
	"Answer whether the receiver is an instance of the class, aClass."

	^self class == aClass! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/23/2003 01:52'!
isMorph
	"forgetAllGrabCommandsFrom: calls this on each object in the image"

	^ false! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/22/2003 22:26'!
perform: selector withArguments: argArray 
	"Send the selector, aSymbol, to the receiver with arguments in argArray.
	Fail if the number of arguments expected by the selector 
	does not match the size of argArray.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 84>
	^ self primitiveFailed! !

!BasicObject methodsFor: 'system primitives' stamp: 'ajh 1/22/2003 22:26'!
respondsTo: aSymbol 
	"Answer whether the method dictionary of the receiver's class contains 
	aSymbol as a message selector."

	^self class canUnderstand: aSymbol! !

!BasicObject methodsFor: 'inspecting' stamp: 'ajh 1/31/2003 15:49'!
basicInspect
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."

	BasicInspector openOn: self withEvalPane: false! !

!BasicObject methodsFor: 'inspecting' stamp: 'ajh 1/23/2003 00:29'!
defaultLabelForInspector
	"Answer the default label to be used for an Inspector window on the receiver."

	^ self class name! !

!BasicObject methodsFor: 'inspecting' stamp: 'ajh 2/3/2003 19:19'!
inspect
	"Create and schedule an Inspector in which the user can examine the receiver's variables."

	self inspectorClass openOn: self withEvalPane: true! !

!BasicObject methodsFor: 'inspecting' stamp: 'ajh 2/3/2003 19:19'!
inspectorClass

	^ Inspector! !

!BasicObject methodsFor: 'printing' stamp: 'ajh 1/23/2003 00:32'!
longPrintOn: aStream
	"Append to the argument, aStream, the names and values of all 
	of the receiver's instance variables."

	self class allInstVarNames doWithIndex:
		[:title :index |
		aStream nextPutAll: title;
		 nextPut: $:;
		 space;
		 tab;
		 print: (self instVarAt: index);
		 cr]! !

!BasicObject methodsFor: 'printing' stamp: 'ajh 1/23/2003 00:31'!
longPrintString
	"Answer a String whose characters are a description of the receiver."
	
	| str |
	str _ String streamContents: [:aStream | self longPrintOn: aStream].
	"Objects without inst vars should return something"
	^ str isEmpty ifTrue: [self printString, String cr] ifFalse: [str]! !

!BasicObject methodsFor: 'printing' stamp: 'ajh 1/23/2003 00:33'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	| title |
	title _ self class name.
	aStream
		nextPutAll: (title first isVowel ifTrue: ['an '] ifFalse: ['a ']);
		nextPutAll: title! !

!BasicObject methodsFor: 'printing' stamp: 'ajh 1/23/2003 00:33'!
printString
	"Answer a String whose characters are a description of the receiver. 
	If you want to print without a character limit, use fullPrintString."

	^ self printStringLimitedTo: 50000! !

!BasicObject methodsFor: 'printing' stamp: 'ajh 1/23/2003 00:33'!
printStringLimitedTo: limit
	"Answer a String whose characters are a description of the receiver.
	If you want to print without a character limit, use fullPrintString."
	| limitedString |
	limitedString _ String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...etc...'! !

!BasicObject methodsFor: 'copying' stamp: 'ajh 1/26/2003 16:35'!
clone

	<primitive: 148>
	self primitiveFailed! !

!BasicObject methodsFor: 'copying' stamp: 'ajh 1/27/2003 18:45'!
copy
	"Answer another instance just like the receiver. Subclasses typically override postCopy; they typically do not override shallowCopy."

	^self shallowCopy postCopy! !

!BasicObject methodsFor: 'copying' stamp: 'ajh 1/27/2003 18:45'!
postCopy
	"self is a shallow copy, subclasses should copy fields as necessary to complete the full copy"

	^ self! !

!BasicObject methodsFor: 'copying' stamp: 'ajh 1/27/2003 18:45'!
shallowCopy
	"Answer a copy of the receiver which shares the receiver's instance variables."
	| class newObject index |
	<primitive: 148>
	class _ self class.
	class isVariable
		ifTrue: 
			[index _ self basicSize.
			newObject _ class basicNew: index.
			[index > 0]
				whileTrue: 
					[newObject basicAt: index put: (self basicAt: index).
					index _ index - 1]]
		ifFalse: [newObject _ class basicNew].
	index _ class instSize.
	[index > 0]
		whileTrue: 
			[newObject instVarAt: index put: (self instVarAt: index).
			index _ index - 1].
	^ newObject! !

!BasicObject methodsFor: 'copying' stamp: 'ajh 1/26/2003 15:08'!
veryDeepCopyWith: deepCopier
	"Copy me and the entire tree of objects I point to.  An object in the tree twice is copied once, and both references point to him.  deepCopier holds a dictionary of objects we have seen.  Some classes refuse to be copied.  Some classes are picky about which fields get deep copied."
	| class index sub subAss new uc sup has mine |
	deepCopier references at: self ifPresent: [:newer | ^ newer]. 	"already did him"
	class _ self class.
	class isMeta ifTrue: [^ self].		"a class"
	new _ self clone.
	class isSystemDefined ifFalse: [
		uc _ deepCopier uniClasses at: class ifAbsent: [nil].
		uc ifNil: [
			deepCopier uniClasses at: class put: (uc _ self copyUniClassWith: deepCopier).
			deepCopier references at: class put: uc].	"remember"
		new _ uc new.
		new copyFrom: self].	"copy inst vars in case any are weak"
	deepCopier references at: self put: new.	"remember"
	(class isVariable and: [class isPointers]) ifTrue: 
		[index _ self basicSize.
		[index > 0] whileTrue: 
			[sub _ self basicAt: index.
			(subAss _ deepCopier references associationAt: sub ifAbsent: [nil])
				ifNil: [new basicAt: index put: (sub veryDeepCopyWith: deepCopier)]
				ifNotNil: [new basicAt: index put: subAss value].
			index _ index - 1]].
	"Ask each superclass if it wants to share (weak copy) any inst vars"
	new veryDeepInner: deepCopier.		"does super a lot"

	"other superclasses want all inst vars deep copied"
	sup _ class.  index _ class instSize.
	[has _ sup compiledMethodAt: #veryDeepInner: ifAbsent: [nil].
	has _ has ifNil: [class isSystemDefined not "is a uniClass"] ifNotNil: [true].
	mine _ sup instVarNames.
	has ifTrue: [index _ index - mine size]	"skip inst vars"
		ifFalse: [1 to: mine size do: [:xx |
				sub _ self instVarAt: index.
				(subAss _ deepCopier references associationAt: sub ifAbsent: [nil])
						"use association, not value, so nil is an exceptional value"
					ifNil: [new instVarAt: index put: 
								(sub veryDeepCopyWith: deepCopier)]
					ifNotNil: [new instVarAt: index put: subAss value].
				index _ index - 1]].
	(sup _ sup superclass) == nil] whileFalse.
	new rehash.	"force Sets and Dictionaries to rehash"
	^ new
! !

!BasicObject methodsFor: 'copying' stamp: 'ajh 1/26/2003 16:39'!
veryDeepFixupWith: deepCopier
	"I have no fields and no superclass.  Catch the super call."
! !

!BasicObject methodsFor: 'copying' stamp: 'ajh 1/26/2003 16:36'!
veryDeepInner: deepCopier
	"No special treatment for inst vars of my superclasses.  Override when some need to be weakly copied.  Object>>veryDeepCopyWith: will veryDeepCopy any inst var whose class does not actually define veryDeepInner:"
! !


!Object methodsFor: 'accessing' stamp: 'ajh 1/21/2003 12:59'!
in: aBlock
	"Evaluate the given block with the receiver as its argument."

	^ aBlock value: self
! !

!Object methodsFor: 'comparing' stamp: 'ajh 2/2/2002 15:02'!
literalEqual: other

	^ self class == other class and: [self = other]! !

!Object methodsFor: 'converting' stamp: 'ajh 3/11/2003 10:27'!
asStringOrText
	"Answer a string that represents the receiver."

	^ self printString ! !

!Object methodsFor: 'copying' stamp: 'ajh 5/23/2002 00:38'!
copySameFrom: otherObject
	"Copy to myself all instance variables named the same in otherObject.
	This ignores otherObject's control over its own inst vars."

	| myInstVars otherInstVars match |
	myInstVars _ self class allInstVarNames.
	otherInstVars _ otherObject class allInstVarNames.
	myInstVars doWithIndex: [:each :index |
		(match _ otherInstVars indexOf: each) > 0 ifTrue:
			[self instVarAt: index put: (otherObject instVarAt: match)]].
	1 to: (self basicSize min: otherObject basicSize) do: [:i |
		self basicAt: i put: (otherObject basicAt: i)].
! !

!Object methodsFor: 'copying' stamp: 'ajh 1/27/2003 18:45'!
postCopy
	"self is a shallow copy, subclasses should copy fields as necessary to complete the full copy"

	^ self! !

!Object methodsFor: 'printing' stamp: 'ajh 9/20/2002 11:03'!
printOn: stream limit: size

	stream nextPutAll: (self printStringLimitedTo: size)! !

!Object methodsFor: 'inspecting' stamp: 'ajh 1/31/2003 15:49'!
basicInspect
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."

	BasicInspector openOn: self withEvalPane: false! !

!Object methodsFor: 'inspecting' stamp: 'ajh 2/3/2003 19:19'!
inspect
	"Create and schedule an Inspector in which the user can examine the receiver's variables."

	self inspectorClass openOn: self withEvalPane: true! !

!Object methodsFor: 'inspecting' stamp: 'ajh 2/3/2003 19:18'!
inspectorClass

	^ Inspector! !

!Object methodsFor: 'enumerating' stamp: 'ajh 9/24/2002 17:51'!
inCollection
	"Polymorphic with collections"

	^ {self}! !

!Object methodsFor: 'enumerating' stamp: 'ajh 9/27/2002 15:34'!
inCollectionDo: block
	"Polymorphic with collections"

	block value: self! !


!Boolean methodsFor: 'printing' stamp: 'ajh 5/23/2001 19:48'!
asBit
	"Return 1 for true, 0 for false"

	^ self subclassResponsibility! !


!Class methodsFor: 'private' stamp: 'ajh 10/9/2001 11:24'!
becomeClass: otherClass
	"Become the otherClass but it gets my name"

	| metaclass nm otherNm |
	otherClass format = self format ifFalse: [self error: 'class format needs to be the same or instances will be interpreted wrong'].

	metaclass _ self class.
	nm _ self name.
	otherNm _ otherClass name.
	self becomeForward: otherClass.
	metaclass becomeForward: otherClass class.
	self setName: nm.
	Smalltalk removeKey: otherNm.
	SystemOrganization removeElement: otherNm.
	Smalltalk garbageCollect.
	self superclass rebuildSubclasses.
	self rebuildSubclasses.
! !

!Class methodsFor: 'private' stamp: 'ajh 10/9/2001 11:33'!
rebuildSubclasses
	"You should probably garbageCollect before calling this"

	| classes |
	classes _ {} writeStream.
	Smalltalk allObjectsDo: [:x |
		(x isBehavior and: [x superclass == self]) ifTrue: [
			classes nextPut: x]].
	subclasses _ classes contents.
! !


!Collection methodsFor: 'accessing' stamp: 'ajh 5/16/2002 22:57'!
sole
	"Return the only element expected in this collection.  Raise an error otherwise"

	self size = 1 ifTrue: [^ self anyOne].
	self size = 0 ifTrue: [^ self errorEmptyCollection].
	^ self errorMoreThanOne! !

!Collection methodsFor: 'accessing' stamp: 'ajh 5/13/2002 21:16'!
soleIfNone: noneBlock ifMany: manyBlock

	self size = 1 ifTrue: [^ self anyOne].
	self size = 0 ifTrue: [^ noneBlock value].
	^ manyBlock value: self! !

!Collection methodsFor: 'adding' stamp: 'ajh 8/19/2001 12:57'!
addIfAbsent: newObject 

	(self includes: newObject) ifFalse: [self add: newObject].
	^ newObject! !

!Collection methodsFor: 'enumerating' stamp: 'ajh 6/12/2002 11:10'!
detect: aBlock ifFound: oneArgBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Evaluate oneArgBlock against the first element for which aBlock evaluates to true.
	If none evaluate to true then return nil"

	self do: [:each | (aBlock value: each) ifTrue: [^ oneArgBlock value: each]].
	^ nil! !

!Collection methodsFor: 'enumerating' stamp: 'ajh 9/24/2002 17:51'!
inCollection
	"Polymorphic with single objects"

	^ self! !

!Collection methodsFor: 'enumerating' stamp: 'ajh 9/27/2002 15:34'!
inCollectionDo: block
	"Polymorphic with single objects"

	self do: block! !

!Collection methodsFor: 'testing' stamp: 'ajh 9/7/2002 02:04'!
isAllEqual
	"Return true if all my elements are equal"

	self size <= 1 ifTrue: [^ true].
	^ self asSet size = 1! !

!Collection methodsFor: 'testing' stamp: 'ajh 8/29/2001 10:51'!
isAllUnique
	"Return true if all my elements are unique from one another"

	^ self asSet size = self size! !


!False methodsFor: 'printing' stamp: 'ajh 5/23/2001 19:49'!
asBit
	"Return 1 for true, 0 for false"

	^ 0! !


!Inspector methodsFor: 'accessing' stamp: 'ajh 2/3/2003 19:19'!
inspect: anObject 
	"Initialize the receiver so that it is inspecting anObject. There is no 
	current selection."

	| c |
	c _ anObject inspectorClass.
	(self class ~= c and: [self class format = c format]) ifTrue: [
		self primitiveChangeClassTo: c basicNew].
	self initialize.
	object _ anObject.
	selectionIndex _ 0.
	contents _ ''! !


!BasicInspector methodsFor: 'as yet unclassified' stamp: 'ajh 1/31/2003 15:49'!
inspect: anObject 
	"Initialize the receiver so that it is inspecting anObject. There is no 
	current selection."

	self initialize.
	object _ anObject.
	selectionIndex _ 0.
	contents _ ''! !


!CompiledMethodInspector methodsFor: 'accessing' stamp: 'ajh 1/18/2003 13:47'!
fieldList

	| keys |
	keys _ OrderedCollection new.
	keys add: 'self'.
	keys add: 'all bytecodes'.
	keys add: 'header'.
	1 to: object numLiterals do: [ :i |
		keys add: 'literal', i printString ].
	object initialPC to: object size do: [ :i |
		keys add: i printString ].
	^ keys asArray
	! !

!CompiledMethodInspector methodsFor: 'selecting' stamp: 'ajh 3/20/2003 00:17'!
contentsIsString
	"Hacked so contents empty when deselected"

	^ #(0 2 3) includes: selectionIndex! !

!CompiledMethodInspector methodsFor: 'selecting' stamp: 'ajh 1/18/2003 13:56'!
selection

	| bytecodeIndex |
	selectionIndex = 0 ifTrue: [^ ''].
	selectionIndex = 1 ifTrue: [^ object ].
	selectionIndex = 2 ifTrue: [^ object symbolic].
	selectionIndex = 3 ifTrue: [^ object headerDescription].
	selectionIndex <= (object numLiterals + 3) 
		ifTrue: [ ^ object objectAt: selectionIndex - 2 ].
	bytecodeIndex _ selectionIndex - object numLiterals - 3.
	^ object at: object initialPC + bytecodeIndex - 1! !

!CompiledMethodInspector methodsFor: 'selecting' stamp: 'ajh 3/20/2001 11:56'!
selectionUnmodifiable
	"Answer if the current selected variable is unmodifiable via acceptance in the code pane.  For most inspectors, no selection and a selection of self (selectionIndex = 1) are unmodifiable"

	^ true! !


!ContextVariablesInspector methodsFor: 'accessing' stamp: 'ajh 1/31/2003 15:45'!
inspect: anObject 
	"Initialize the receiver so that it is inspecting anObject. There is no 
	current selection."

	self initialize.
	object _ anObject.
	selectionIndex _ 0.
	contents _ ''! !


!InstructionPrinter methodsFor: 'initialize-release' stamp: 'ajh 3/20/2001 11:30'!
printInstruction: aPc on: aStream 
	"Append to the stream, aStream, a description of the bytecode at aPic in the 
	instruction stream."
	
	stream _ aStream.
	oldPC _ pc _ aPc.
	super interpretNextInstructionFor: self! !


!LookupKey methodsFor: 'accessing' stamp: 'ajh 3/24/2003 21:14'!
name

	^ self key isString
		ifTrue: [self key]
		ifFalse: [self key printString]! !


!Message methodsFor: 'accessing' stamp: 'ajh 10/9/2001 16:32'!
lookupClass

	^ lookupClass! !

!Message methodsFor: 'printing' stamp: 'ajh 10/9/2001 15:31'!
printOn: stream

	args isEmpty ifTrue: [^ stream nextPutAll: selector].
	args with: selector keywords do: [:arg :word |
		stream nextPutAll: word.
		stream space.
		arg printOn: stream.
		stream space.
	].
	stream skip: -1.
! !

!Message methodsFor: 'private' stamp: 'ajh 9/23/2001 04:59'!
lookupClass: aClass

	lookupClass _ aClass! !

!Message methodsFor: 'private' stamp: 'ajh 3/9/2003 19:25'!
setSelector: aSymbol

	selector _ aSymbol.
! !

!Message methodsFor: 'sending' stamp: 'ajh 1/22/2003 11:51'!
sendTo: receiver
	"answer the result of sending this message to receiver"

	^ receiver perform: selector withArguments: args! !


!Number methodsFor: 'intervals' stamp: 'ajh 9/27/2002 21:20'!
extend: size

	^ self to: self + size - 1! !


!Integer methodsFor: 'tiles' stamp: 'ajh 8/13/2002 18:10'!
dummySelector
	"Answer a dummy selector with self number of args"

	| sel |
	sel _ 'unknown'.
	1 to: self do: [:i |
		sel _ sel, 'with:'].
	^ sel asSymbol! !


!LargePositiveInteger methodsFor: 'converting' stamp: 'ajh 7/25/2001 22:28'!
as31BitSmallInt
	"This is only for 31 bit numbers.  Keep my 31 bits the same, but put them in a small int.  The small int will be negative since my 31st bit is 1.  We know my 31st bit is 1 because otherwise I would already be a positive small int."

	self highBit = 31 ifFalse: [self error: 'more than 31 bits can not fit in a SmallInteger'].

	^ self - 16r80000000! !


!Object class methodsFor: 'instance creation' stamp: 'ajh 5/23/2002 00:35'!
newFrom: aSimilarObject
	"Create an object that has similar contents to aSimilarObject.
	If the classes have any instance varaibles with the same names, copy them across.
	If this is bad for a class, override this method."

	^ (self isVariable
		ifTrue: [self basicNew: aSimilarObject basicSize]
		ifFalse: [self basicNew]
	  ) copySameFrom: aSimilarObject! !


!SequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 17:53'!
atLast: indexFromEnd
	"Return element at indexFromEnd from the last position.
	 atLast: 1, returns the last element"

	^ self atLast: indexFromEnd ifAbsent: [self errorIndexOutOfRange]! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 17:52'!
atLast: indexFromEnd ifAbsent: block
	"Return element at indexFromEnd from the last position.
	 atLast: 1 ifAbsent: [] returns the last element"

	^ self at: self size + 1 - indexFromEnd ifAbsent: block! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 18:10'!
atLast: indexFromEnd put: obj
	"Set the element at indexFromEnd from the last position.
	 atLast: 1 put: obj, sets the last element"

	^ self at: self size + 1 - indexFromEnd put: obj! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'ajh 8/18/2001 19:04'!
indicesOf: subSet

	^ subSet collect: [:x | self indexOf: x ifAbsent: [self errorNotFound: x]]! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'ajh 12/29/2001 23:24'!
setLast: obj
	"Set the last element of the receiver.
	Raise an error if the collection is empty."

	| size |
	(size _ self size) = 0 ifTrue: [self errorEmptyCollection].
	^ self at: size put: obj! !

!SequenceableCollection methodsFor: 'copying' stamp: 'ajh 9/13/2002 21:47'!
copyGrowBy: delta
	"Return a copy of self whose size is larger by delta.  The new elements will be filled in with nil or zero depending on the type of class (holds pointers or bytes/words)"

	| copy |
	copy _ self species ofSize: self size + delta.
	copy replaceFrom: 1 to: self size with: self startingAt: 1.
	^ copy! !

!SequenceableCollection methodsFor: 'copying' stamp: 'ajh 9/13/2002 21:49'!
copyGrowTo: newSize
	"Return a copy of self whose size is newSize (assumed larger or equal to self size).  The new elements will be filled in with nil or zero depending on the type of class (holds pointers or bytes/words)"

	^ self copyGrowBy: newSize - self size! !

!SequenceableCollection methodsFor: 'copying' stamp: 'ajh 9/27/2002 12:09'!
copyWithFirst: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver with newElement as the first element."

	| newIC |
	newIC _ self species ofSize: self size + 1.
	newIC 
		replaceFrom: 2
		to: self size + 1
		with: self
		startingAt: 1.
	newIC at: 1 put: newElement.
	^ newIC! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 15:03'!
allButFirstDo: block

	2 to: self size do:
		[:index | block value: (self at: index)]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 15:01'!
allButLastDo: block

	1 to: self size - 1 do:
		[:index | block value: (self at: index)]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/23/2001 12:07'!
collectArray: aBlock 
	"Same as collect: except always return an array"

	| newCollection |
	newCollection _ Array new: self size.
	1 to: self size do:
		[:index |
		newCollection at: index put: (aBlock value: (self at: index))].
	^ newCollection! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/27/2001 11:07'!
convert: block
	"Change my elements using block"

	1 to: self size do:
		[:index | self at: index put: (block value: (self at: index))]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/3/2001 20:58'!
detectIndex: block

	^ self detectIndex: block ifNone: [self errorNotFound: block]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/3/2001 20:58'!
detectIndex: block ifNone: absentBlock

	1 to: self size do: [:i |
		(block value: (self at: i)) ifTrue: [^ i]].
	^ absentBlock value! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 3/13/2003 13:10'!
reverseDetect: block

	^ self reverseDetect: block ifNone: [self errorNotFound]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 10:58'!
reverseDetect: block ifNone: absentBlock

	self size to: 1 by: -1 do: [:i |
		(block value: (self at: i)) ifTrue: [^ self at: i]].
	^ absentBlock value! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/11/2001 12:26'!
reverseDetectIndex: block ifNone: absentBlock

	self size to: 1 by: -1 do: [:i |
		(block value: (self at: i)) ifTrue: [^ i]].
	^ absentBlock value! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 1/5/2002 01:33'!
with: otherCollection padding: fillObj collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with corresponding elements from this collection and otherCollection.  If one collection is short substitute fillObj as necessary to finish the other collection"

	| firstSize secondSize result |
	firstSize _ self size.
	secondSize _ otherCollection size.
	result _ Array new: (firstSize max: secondSize).
	1 to: result size do: [:i |
	   result at: i put: (twoArgBlock
		value: (i > firstSize ifTrue: [fillObj] ifFalse: [self at: i])
		value: (i > secondSize ifTrue: [fillObj] ifFalse: [otherCollection at: i])
	   )
	].
	^ result! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 1/5/2002 01:05'!
with: otherCollection padding: fillObj do: twoArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection.  If one collection is short substitute fillObj as necessary to finish the other collection"

	| firstSize secondSize |
	firstSize _ self size.
	secondSize _ otherCollection size.
	1 to: (firstSize max: secondSize) do: [:i |
	   twoArgBlock
		value: (i > firstSize ifTrue: [fillObj] ifFalse: [self at: i])
		value: (i > secondSize ifTrue: [fillObj] ifFalse: [otherCollection at: i])
	].
! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/17/2001 21:02'!
with: otherCollection withIndexDo: threeArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection."

	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	1 to: self size do: [:index |
		threeArgBlock 
			value: (self at: index)
			value: (otherCollection at: index)
			value: index]! !

!SequenceableCollection methodsFor: 'removing' stamp: 'ajh 9/23/2002 18:03'!
removeAnyOne

	^ self removeFirst! !

!SequenceableCollection methodsFor: 'testing' stamp: 'ajh 3/3/2003 21:38'!
endSatisfies: blocks
	"Return true if each element at end of list satisfies its corresponding block.  The number of elements tested equals the number of blocks.  If not enough elements return false"

	| i |
	blocks size > self size ifTrue: [^ false].
	i _ self size - blocks size.
	blocks do: [:b |
		(b value: (self at: (i _ i + 1))) ifFalse: [^ false].
	].
	^ true

"#(1 2 3) endSatisfies: {[:x | x even]. [:x | x odd]}"! !

!SequenceableCollection methodsFor: 'testing' stamp: 'ajh 3/10/2003 16:04'!
satisfies: blocks
	"Return true if each element satisfies its corresponding block"

	self with: blocks do: [:elem :block |
		(block value: elem) ifFalse: [^ false].
	].
	^ true

"#(2 3) satisfies: {[:x | x even]. [:x | x odd]}"! !

!SequenceableCollection methodsFor: 'moving' stamp: 'ajh 2/2/2002 15:37'!
slide: interval by: distance
	"Move the elements in inteval down(neg)/up(pos) by distance while sliding elements it displaces the other way"

	^ distance > 0
		ifTrue: [self slide: interval up: distance]
		ifFalse: [self slide: interval down: distance]! !

!SequenceableCollection methodsFor: 'moving' stamp: 'ajh 2/2/2002 16:27'!
slide: interval down: distance
	"Destructively move the elements in inteval down by distance while sliding elements it displaces up by interval size"

	| displacedInterval displaced |
	displacedInterval _ interval first - distance to: interval first - 1.
	displaced _ self atAll: displacedInterval.
	self replaceFrom: displacedInterval first to: displacedInterval first + interval size - 1 with: self startingAt: interval first.
	self replaceFrom: displacedInterval first + interval size to: interval last with: displaced.

"{$a. $b. $c. $d. $e} slide: (3 to: 5) down: 2"! !

!SequenceableCollection methodsFor: 'moving' stamp: 'ajh 2/2/2002 17:35'!
slide: interval up: distance
	"Destructively move the elements in inteval up by distance while sliding elements it displaces down by interval size"

	| displacedInterval elements |
	displacedInterval _ interval last + 1 to: interval last + distance.
	elements _ self atAll: interval.
	self replaceFrom: interval first to: interval first + displacedInterval size - 1 with: self startingAt: displacedInterval first.
	self replaceFrom: interval first + displacedInterval size to: displacedInterval last with: elements.

"{$a. $b. $c. $d. $e} slide: (1 to: 2) up: 2"! !


!Array methodsFor: 'comparing' stamp: 'ajh 2/2/2002 15:03'!
literalEqual: other

	self class == other class ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	self with: other do: [:e1 :e2 |
		(e1 literalEqual: e2) ifFalse: [^ false]].
	^ true! !

!Array methodsFor: 'converting' stamp: 'ajh 9/8/2002 17:45'!
elementsExchangeIdentityWith: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  At the same time, all pointers to the elements of otherArray are replaced by pointers to the corresponding elements of this array.  The identityHashes remain with the pointers rather than with the objects so that objects in hashed structures should still be properly indexed after the mutation."

	<primitive: 128>
	otherArray class == Array ifFalse: [^ self error: 'arg must be array'].
	self size = otherArray size ifFalse: [^ self error: 'arrays must be same size'].
	(self anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	(otherArray anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].

	"Must have failed because not enough space in forwarding table (see ObjectMemory-prepareForwardingTableForBecoming:with:twoWay:).  Do GC and try again only once"
	(Smalltalk bytesLeft: true) = Smalltalk primitiveGarbageCollect
		ifTrue: [^ self primitiveFailed].
	^ self elementsExchangeIdentityWith: otherArray! !


!CompiledMethod methodsFor: 'comparing' stamp: 'ajh 1/31/2003 17:13'!
= method
	"Answer whether the receiver implements the same code as the 
	argument, method."

	(method isKindOf: CompiledMethod) ifFalse: [^false].
	self endPC = method endPC ifFalse: [^false].
	self header = method header ifFalse: [^false].
	self initialPC to: self endPC do:
		[:i | (self at: i) = (method at: i) ifFalse: [^false]].
	^ self literals literalEqual: method literals! !

!CompiledMethod methodsFor: 'printing' stamp: 'ajh 2/9/2003 14:17'!
longPrintOn: aStream
	"List of all the byte codes in a method with a short description of each" 

	self longPrintOn: aStream indent: 0! !

!CompiledMethod methodsFor: 'printing' stamp: 'ajh 3/20/2001 11:41'!
symbolic
	"Answer a String that contains a list of all the byte codes in a method 
	with a short description of each."

	| aStream |
	aStream _ WriteStream on: (String new: 1000).
	self longPrintOn: aStream.
	^aStream contents! !

!CompiledMethod methodsFor: 'literals' stamp: 'ajh 2/9/2003 13:15'!
headerDescription
	"Answer a description containing the information about the form of the 
	receiver and the form of the context needed to run the receiver."

	| s |
	s _ '' writeStream.
	self header printOn: s.
	s cr; nextPutAll: '"primitive: '.
	self primitive printOn: s.
	s cr; nextPutAll: ' numArgs: '.
	self numArgs printOn: s.
	s cr; nextPutAll: ' numTemps: '.
	self numTemps printOn: s.
	s cr; nextPutAll: ' numLiterals: '.
	self numLiterals printOn: s.
	s cr; nextPutAll: ' frameSize: '.
	self frameSize printOn: s.
	s cr; nextPutAll: ' isClosureCompiled: '.
	self isClosureCompiled printOn: s.
	s nextPut: $"; cr.
	^ s contents! !

!CompiledMethod methodsFor: 'user interface' stamp: 'ajh 2/3/2003 19:18'!
inspectorClass

	^ CompiledMethodInspector! !


!Interval methodsFor: 'arithmetic' stamp: 'ajh 3/13/2003 15:45'!
+ number

	^ start + number to: stop + number by: step! !

!Interval methodsFor: 'arithmetic' stamp: 'ajh 3/13/2003 15:46'!
- number

	^ start - number to: stop - number by: step! !


!LinkedList methodsFor: 'accessing' stamp: 'ajh 8/6/2002 15:46'!
at: index

	| i |
	i _ 0.
	self do: [:link |
		(i _ i + 1) = index ifTrue: [^ link]].
	^ self errorSubscriptBounds: index! !

!LinkedList methodsFor: 'adding' stamp: 'ajh 8/22/2002 14:17'!
add: link before: otherLink

	| aLink |
	firstLink == otherLink ifTrue: [^ self addFirst: link].
	aLink _ firstLink.
	[aLink == nil] whileFalse: [
		aLink nextLink == otherLink ifTrue: [
			link nextLink: aLink nextLink.
			aLink nextLink: link.
			^ link
		].
		 aLink _ aLink nextLink.
	].
	^ self errorNotFound: otherLink! !

!LinkedList methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 16:39'!
species

	^ Array! !


!OrderedCollection methodsFor: 'adding' stamp: 'ajh 3/13/2003 17:23'!
at: index ifAbsentAdd: block
	"Return value at index, however, if value does not exist (nil or out of bounds) then add block's value at index (growing self if necessary)"

	| v |
	index <= self size ifTrue: [
		^ (v _ self at: index)
			ifNotNil: [v]
			ifNil: [self at: index put: block value]
	].
	[self size < index] whileTrue: [self add: nil].
	^ self at: index put: block value! !

!OrderedCollection methodsFor: 'removing' stamp: 'ajh 8/13/2002 17:07'!
removeAll

	firstIndex to: lastIndex do: [:i | array at: i put: nil].
	self reset! !

!OrderedCollection methodsFor: 'private' stamp: 'ajh 7/25/2002 22:52'!
insertNils: n at: i
	"Slide elements from i to self size up by n slots.  Fill in gap with nils"

	1 to: n do: [:j | self add: nil].
	self slide: (i to: self size - n) up: n.

"#(a b c d e) asOrderedCollection insertNils: 2 at: 3"! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 10/3/2002 17:29'!
bottom

	^ self first! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/20/2001 13:04'!
pop

	^ self removeLast! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/27/2002 17:20'!
pop: n
	"Pop top n object into an array with top in last position"

	| list |
	list _ Array new: n.
	n to: 1 by: -1 do: [:i |
		list at: i put: self pop].
	^ list! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/30/2002 17:13'!
popTo: index
	"Pop objects into an array until topIndex is at index"

	^ self pop: (self size - index)! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/20/2001 13:04'!
push: obj

	^ self addLast: obj! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 10/1/2002 12:59'!
pushAll: obj

	^ self addAll: obj! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/20/2001 13:04'!
top

	^ self last! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 3/1/2003 17:04'!
top: index

	^ self atLast: index! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 10/3/2002 17:35'!
topToBottomDo: block

	self reverseDo: block! !


!Set methodsFor: 'removing' stamp: 'ajh 7/20/2001 19:19'!
removeAnyOne

	| elem |
	1 to: array size do: [:i |
		elem _ array at: i.
		elem ifNotNil: [
			array at: i put: nil.
			tally _ tally - 1.
			self fixCollisionsFrom: i.
			^ elem]
	].
	self errorEmptyCollection.
! !


!Dictionary methodsFor: 'accessing' stamp: 'ajh 8/16/2002 02:44'!
anyKey

	self keysDo: [:key | ^ key].
	^ self errorEmptyCollection! !

!Dictionary methodsFor: 'accessing' stamp: 'ajh 5/17/2002 00:12'!
associationAt: key ifPresent: aBlock 

	| index assoc |
	index _ self findElementOrNil: key.
	assoc _ array at: index.
	assoc ifNotNil: [^ aBlock value: assoc].
	^ nil! !

!Dictionary methodsFor: 'accessing' stamp: 'ajh 8/27/2001 11:05'!
associations
	"Answer an OrderedCollection containing the receiver's associations in an 
	arbitrary order."

	| aCollection |
	aCollection := OrderedCollection new: self size.
	self associationsDo: [:assn | aCollection add: assn].
	^aCollection! !

!Dictionary methodsFor: 'accessing' stamp: 'ajh 5/14/2002 01:45'!
keysSorted
	"Answer a SortedCollection containing the receiver's keys."

	| sortedKeys |
	sortedKeys _ SortedCollection new: self size.
	self keysDo: [:each | sortedKeys addLast: each].
	^ sortedKeys reSort! !

!Dictionary methodsFor: 'adding' stamp: 'ajh 8/30/2001 19:05'!
addDict: dictionary

	dictionary keysAndValuesDo: [:key :value |
		self at: key put: value].
! !

!Dictionary methodsFor: 'enumerating' stamp: 'ajh 8/28/2001 20:53'!
collectDict: aBlock 
	"Evaluate aBlock with each of my values as the argument.  Collect the
	resulting values into a collection that is like me. Answer with the new
	collection."

	| newDict |
	newDict _ self species new: self size.
	self keysAndValuesDo: [:key :value | 
		newDict at: key put: (aBlock value: value)].
	^ newDict! !

!Dictionary methodsFor: 'enumerating' stamp: 'ajh 8/27/2001 11:05'!
convert: block
	"Change my values in self using block"

	self associationsDo: [:assoc |
		assoc value: (block value: assoc value)]! !


!KeyedSet methodsFor: 'testing' stamp: 'ajh 9/5/2000 03:45'!
includes: anObject 
	^ (array at: (self findElementOrNil: (keyBlock value: anObject))) ~~ nil! !

!KeyedSet methodsFor: 'testing' stamp: 'ajh 3/29/2001 23:56'!
includesKey: key

	^ (array at: (self findElementOrNil: key)) ~~ nil! !

!KeyedSet methodsFor: 'private' stamp: 'ajh 3/29/2001 19:04'!
errorKeyNotFound

	self error: 'key not found'! !

!KeyedSet methodsFor: 'private' stamp: 'ajh 9/5/2000 03:44'!
fixCollisionsFrom: index
	"The element at index has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"
	| length oldIndex newIndex element |
	oldIndex _ index.
	length _ array size.
	[oldIndex = length
			ifTrue: [oldIndex _  1]
			ifFalse: [oldIndex _  oldIndex + 1].
	(element _ self keyAt: oldIndex) == nil]
		whileFalse: 
			[newIndex _ self findElementOrNil: (keyBlock value: element).
			oldIndex = newIndex ifFalse: [self swap: oldIndex with: newIndex]]! !

!KeyedSet methodsFor: 'private' stamp: 'ajh 9/7/2001 11:56'!
init: n
	super init: n.
	keyBlock _ [:element | element key].
! !

!KeyedSet methodsFor: 'private' stamp: 'ajh 9/5/2000 03:46'!
noCheckAdd: anObject
	array at: (self findElementOrNil: (keyBlock value: anObject)) put: anObject.
	tally _ tally + 1! !

!KeyedSet methodsFor: 'private' stamp: 'ajh 12/13/2001 00:17'!
rehash
	| newSelf |
	newSelf _ self species new: self size.
	newSelf keyBlock: keyBlock.
	self do: [:each | newSelf noCheckAdd: each].
	array _ newSelf array! !

!KeyedSet methodsFor: 'private' stamp: 'ajh 9/5/2000 03:55'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	start _ (anObject hash \\ array size) + 1.
	finish _ array size.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element _ array at: index) == nil or: [(keyBlock value: element) = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element _ array at: index) == nil or: [(keyBlock value: element) = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!KeyedSet methodsFor: 'adding' stamp: 'ajh 12/4/2001 05:35'!
add: newObject
	"Include newObject as one of the receiver's elements, but only if
	not already present. Answer newObject."

	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index _ self findElementOrNil: (keyBlock value: newObject).
	(array at: index) ifNotNil: [^ self errorKeyAlreadyExists: (array at: index)].
	self atNewIndex: index put: newObject.
	^ newObject! !

!KeyedSet methodsFor: 'adding' stamp: 'ajh 12/4/2001 05:27'!
addAll: aCollection 
	"Include all the elements of aCollection as the receiver's elements"

	(aCollection respondsTo: #associationsDo:)
		ifTrue: [aCollection associationsDo: [:ass | self add: ass]]
		ifFalse: [aCollection do: [:each | self add: each]].
	^ aCollection! !

!KeyedSet methodsFor: 'adding' stamp: 'ajh 6/3/2002 10:11'!
member: newObject
	"Include newObject as one of the receiver's elements, if already exists just return it"

	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index _ self findElementOrNil: (keyBlock value: newObject).
	(array at: index) ifNotNil: [^ array at: index].
	self atNewIndex: index put: newObject.
	^ newObject! !

!KeyedSet methodsFor: 'accessing' stamp: 'ajh 9/5/2000 03:57'!
at: key 
	"Answer the value associated with the key."

	^ self at: key ifAbsent: [self errorKeyNotFound]! !

!KeyedSet methodsFor: 'accessing' stamp: 'ajh 10/6/2000 20:28'!
at: key ifAbsent: aBlock 
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."

	| obj |
	obj _ array at: (self findElementOrNil: key).
	obj ifNil: [^ aBlock value].
	^ obj! !

!KeyedSet methodsFor: 'accessing' stamp: 'ajh 12/10/2000 15:42'!
at: key ifAbsentPut: aBlock 
	"Answer the value associated with the key or, if key isn't found,
	add the result of evaluating aBlock to self"

	^ self at: key ifAbsent: [self add: aBlock value]! !

!KeyedSet methodsFor: 'accessing' stamp: 'ajh 9/5/2000 03:58'!
at: key ifPresent: aBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	| v |
	v _ self at: key ifAbsent: [^ nil].
	^ aBlock value: v
! !

!KeyedSet methodsFor: 'accessing' stamp: 'ajh 5/11/2002 13:28'!
keys

	| keys |
	keys _ Set new.
	self do: [:item | keys add: (keyBlock value: item)].
	^ keys! !

!KeyedSet methodsFor: 'accessing' stamp: 'ajh 5/11/2002 13:28'!
keysSorted

	| keys |
	keys _ SortedCollection new.
	self do: [:item | keys add: (keyBlock value: item)].
	^ keys! !

!KeyedSet methodsFor: 'removing' stamp: 'ajh 9/5/2000 03:47'!
remove: oldObject ifAbsent: aBlock

	| index |
	index _ self findElementOrNil: (keyBlock value: oldObject).
	(array at: index) == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally _ tally - 1.
	self fixCollisionsFrom: index.
	^ oldObject! !

!KeyedSet methodsFor: 'removing' stamp: 'ajh 3/29/2001 19:03'!
removeKey: key 

	^ self removeKey: key ifAbsent: [self errorKeyNotFound]! !

!KeyedSet methodsFor: 'removing' stamp: 'ajh 3/29/2001 19:03'!
removeKey: key ifAbsent: aBlock

	| index obj |
	index _ self findElementOrNil: key.
	(obj _ array at: index) == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally _ tally - 1.
	self fixCollisionsFrom: index.
	^ obj! !

!KeyedSet methodsFor: 'copying' stamp: 'ajh 9/5/2000 03:56'!
copy
	^super copy postCopyBlocks! !

!KeyedSet methodsFor: 'copying' stamp: 'ajh 9/5/2000 03:56'!
postCopyBlocks
	keyBlock _ keyBlock copy.
	"Fix temps in case we're referring to outside stuff"
	keyBlock fixTemps.! !

!KeyedSet methodsFor: 'initialize' stamp: 'ajh 9/5/2000 03:36'!
keyBlock: oneArgBlock
	"When evaluated return the key of the argument which will be an element of the set"

	keyBlock _ oneArgBlock! !


!KeyedIdentitySet methodsFor: 'private' stamp: 'ajh 12/10/2000 20:24'!
scanFor: anObject
	"Same as super except change = to ==, and hash to identityHash"

	| element start finish |
	start _ (anObject identityHash \\ array size) + 1.
	finish _ array size.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element _ array at: index) == nil or: [(keyBlock value: element) == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element _ array at: index) == nil or: [(keyBlock value: element) == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !


!KeyedSet class methodsFor: 'instance creation' stamp: 'ajh 10/23/2000 23:16'!
keyBlock: oneArgBlock
	"Create a new KeySet whose way to access an element's key is by executing oneArgBlock on the element"

	^ self new keyBlock: oneArgBlock! !


!SmallInteger methodsFor: 'converting' stamp: 'ajh 7/25/2001 22:34'!
as31BitSmallInt
	"Polymorphic with LargePositiveInteger (see comment there).
	 Return self since all SmallIntegers are 31 bits"

	^ self! !


!Stream methodsFor: 'accessing' stamp: 'ajh 7/31/2001 20:34'!
printOn: stream

	super printOn: stream.
	stream space.
	self contents printOn: stream.
! !

!Stream methodsFor: 'enumerating' stamp: 'ajh 12/29/2001 18:04'!
includes: obj

	| pos result |
	pos _ self position.
	self setToEnd.
	result _ self contents includes: obj.
	self position: pos.
	^ result! !


!PositionableStream methodsFor: 'accessing' stamp: 'ajh 9/22/2001 01:16'!
at: pos
	"Return the element at pos"

	pos > readLimit ifTrue: [self errorOutOfBounds].
	^ collection at: pos! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 1/18/2002 01:03'!
back
	"Go back one element and return it.  Use indirect messages in case I am a StandardFileStream"

	self position = 0 ifTrue: [self errorCantGoBack].
	self position = 1 ifTrue: [self position: 0.  ^ nil].
	self skip: -2.
	^ self next
! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 7/17/2001 21:49'!
copyIntoStream: aWriteStream

	1 to: position do: [:i |
		aWriteStream nextPut: (collection at: i)]! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 5/18/2001 21:42'!
current
	"Return the element at the current position"

	^ collection at: position! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 7/18/2001 00:22'!
do: block

	1 to: readLimit do: [:i |
		block value: (collection at: i)]! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 1/18/2002 01:02'!
peekBack
	"Return the element at the previous position, without changing position.  Use indirect messages in case self is a StandardFileStream."

	| element |
	element _ self back.
	self skip: 1.
	^ element! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 7/30/2001 02:24'!
previous
	"Return the element at the previous position"

	^ collection at: position - 1! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 1/22/2003 17:56'!
rest

	| p rest |
	p _ self position.
	rest _ self upToEnd.
	self position: p.
	^ rest! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 7/17/2001 21:49'!
reverseCopyIntoStream: aWriteStream

	position to: 1 by: -1 do: [:i |
		aWriteStream nextPut: (collection at: i)]! !

!PositionableStream methodsFor: 'testing' stamp: 'ajh 6/18/2002 12:55'!
identityIncludes: obj

	| pos |
	pos _ self position.
	self setToEnd.
	1 to: self position do: [:i |
		(collection at: i) == obj ifTrue: [
			self position: pos.
			^ true]
	].
	self position: pos.
	^ false! !

!PositionableStream methodsFor: 'testing' stamp: 'ajh 12/29/2001 21:51'!
includes: obj

	| pos |
	pos _ self position.
	self setToEnd.
	1 to: self position do: [:i |
		(collection at: i) = obj ifTrue: [
			self position: pos.
			^ true]
	].
	self position: pos.
	^ false! !

!PositionableStream methodsFor: 'testing' stamp: 'ajh 7/21/2001 12:57'!
notEmpty

	^ self isEmpty not! !

!PositionableStream methodsFor: 'fileIn/Out' stamp: 'ajh 1/18/2002 01:02'!
backChunk
	"Answer the contents of the receiver back to the previous terminator character.  Doubled terminators indicate an embedded terminator character."
	| terminator out ch |
	terminator _ $!!.
	out _ WriteStream on: (String new: 1000).
	[(ch _ self back) == nil] whileFalse: [
		(ch == terminator) ifTrue: [
			self peekBack == terminator ifTrue: [
				self back.  "skip doubled terminator"
			] ifFalse: [
				^ out contents reversed  "we're done!!"
			].
		].
		out nextPut: ch.
	].
	^ out contents reversed! !


!ReadStream methodsFor: 'accessing' stamp: 'ajh 9/5/2002 22:11'!
readStream
	"polymorphic with SequenceableCollection.  Return self"

	^ self! !


!String methodsFor: 'converting' stamp: 'ajh 5/18/2001 11:56'!
uniqueAmong: wordList
	"Return a string like self that is unique among wordList"

	| candidate n |
	n _ 0.
	candidate _ self.
	[wordList includes: candidate] whileTrue: [
		candidate _ self, (n _ n + 1) printString].
	^ candidate! !

!String methodsFor: 'user interface' stamp: 'ajh 9/25/2002 13:10'!
asExplorerString
	^ self printString! !

!String methodsFor: 'compiling' stamp: 'ajh 10/3/2002 19:56'!
inCollection
	"Polymorphic with single objects"

	^ {self}! !


!Text methodsFor: 'private' stamp: 'ajh 10/3/2002 19:57'!
inCollection
	"Polymorphic with single objects"

	^ {self}! !


!TextColor class methodsFor: 'constants' stamp: 'ajh 9/10/2002 02:26'!
gray
	^ self new color: Color gray! !


!True methodsFor: 'printing' stamp: 'ajh 5/23/2001 19:49'!
asBit
	"Return 1 for true, 0 for false"

	^ 1! !


!UndefinedObject methodsFor: 'enumerating' stamp: 'ajh 9/24/2002 17:51'!
inCollection
	"Polymorphic with Collection and Object"

	^ #()! !

!UndefinedObject methodsFor: 'enumerating' stamp: 'ajh 9/27/2002 15:35'!
inCollectionDo: block
	"Polymorphic with Collection and Object"

	"do nothing"! !


!WriteStream methodsFor: 'accessing' stamp: 'ajh 9/22/2001 01:19'!
at: pos
	"Return the element at pos"

	readLimit _ readLimit max: position.
	^ super at: pos! !

!WriteStream methodsFor: 'accessing' stamp: 'ajh 9/22/2001 01:19'!
at: pos put: value
	"Set the element at pos"

	pos > (readLimit _ readLimit max: position) ifTrue: [self errorOutOfBounds].
	^ collection at: pos put: value! !

!WriteStream methodsFor: 'accessing' stamp: 'ajh 7/18/2001 00:25'!
do: block

	readLimit _ readLimit max: position.
	1 to: position do: [:i |
		block value: (collection at: i)]! !

!WriteStream methodsFor: 'positioning' stamp: 'ajh 7/27/2001 23:07'!
resetTo: pos
	readLimit _ position _ pos.! !

!WriteStream methodsFor: 'positioning' stamp: 'ajh 5/25/2001 20:19'!
setToEnd 
	"Refer to the comment in PositionableStream|setToEnd."

	readLimit _ readLimit max: position.
	super setToEnd.! !

!WriteStream methodsFor: 'character writing' stamp: 'ajh 2/9/2003 14:15'!
tabs: numTabs
	"Append numTabs tab characters to the receiver."

	numTabs timesRepeat: [self tab]! !

!WriteStream methodsFor: 'private' stamp: 'ajh 8/2/2001 12:42'!
pastEndPut: anObject
	collection _ collection ,
		(collection class new: ((collection size max: 20) min: 20000)).
	writeLimit _ collection size.
	^ collection at: (position _ position + 1) put: anObject! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 8/25/2001 10:45'!
current: obj
	"Set the element at the current position"

	^ collection at: position put: obj! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 7/18/2001 00:19'!
insert: obj

	^ self insertAll: {obj}! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 8/1/2001 19:35'!
insertAll: coll
	"slide all elements after current position forward by coll size, then insert coll elements in the new positions.  My position will point to the last inserted element"

	| n |
	n _ coll size.
	readLimit + n > writeLimit ifTrue: [
		collection _ collection, (collection class new: n).
		writeLimit _ collection size].
	readLimit to: position + 1 by: -1 do: [:i |
		collection at: i + n put: (collection at: i)].
	1 to: n do: [:i |
		collection at: position + i put: (coll at: i)].
	readLimit _ readLimit + n.
	position _ position + n.


" #() writeStream 
	nextPut: $a;
	nextPut: $b;
	nextPut: $c;
	position: 1;
	insertAll: #($x $y);
	setToEnd;
	contents "! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 7/20/2001 19:43'!
insertNext: n
	"slide all elements after current position forward by n, while inserting zeros in next n elements (zeros are used in case collection is a ByteArray).  Keep position the same"

	readLimit + n > writeLimit ifTrue: [
		collection _ collection, (collection class new: n).
		writeLimit _ collection size].
	readLimit to: position + 1 by: -1 do: [:i |
		collection at: i + n put: (collection at: i)].
	position + 1 to: position + n do: [:i |
		collection at: i put: 0].
	readLimit _ readLimit + n.

"
 #() writeStream 
	nextPut: $a;
	nextPut: $b;
	nextPut: $c;
	position: 1;
	insertNext: 2;
	setToEnd;
	contents
"! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 8/20/2001 23:45'!
removeCurrent
	"Remove element under current position (sliding those after it down by one).  Move position back by one (point to the previous element)"

	self skip: -1.
	self removeNext: 1.
! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 7/27/2001 21:54'!
removeFirst

	| pos |
	pos _ self position.
	self reset.
	self removeNext.
	self position: pos - 1.! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 5/25/2001 17:50'!
removeNext
	"slide all elements after current position down by one, removing the next element.  Keep position the same"

	self atEnd ifTrue: [^ nil].
	self removeNext: 1! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 5/21/2001 19:17'!
removeNext: n
	"slide all elements after current position down by n, removing the next n element.  Keep position the same"

	collection 
		replaceFrom: position + 1 
		to: readLimit - n 
		with: collection 
		startingAt: position + 1 + n.
	readLimit _ readLimit - n.

"
 #() writeStream 
	nextPut: $a;
	nextPut: $b;
	nextPut: $c;
	nextPut: $d;
	position: 1;
	removeNext: 2;
	setToEnd;
	contents
"! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 7/20/2001 19:43'!
shiftNext: delta
	"Shift my elements from next to end by delta positions.  If negative, the next delta elements will be removed.  If positive, zeros will be inserted.  The position will remain the same"

	delta < 0
		ifTrue: [self removeNext: 0 - delta]
		ifFalse: [self insertNext: delta]! !


!ReadWriteStream methodsFor: 'accessing' stamp: 'ajh 7/18/2001 00:24'!
do: block

	readLimit _ readLimit max: position.
	1 to: readLimit do: [:i |
		block value: (collection at: i)]! !

!ReadWriteStream methodsFor: 'accessing' stamp: 'ajh 7/30/2001 22:41'!
pop

	^ (self popAll: 1) first! !

!ReadWriteStream methodsFor: 'accessing' stamp: 'ajh 7/30/2001 02:39'!
popAll: n

	| coll |
	self skip: 0 - n.
	coll _ self next: n.
	self skip: 0 - n.
	self removeNext: n.
	^ coll! !

!ReadWriteStream methodsFor: 'converting' stamp: 'ajh 9/14/2002 20:37'!
readStream
	"polymorphic with SequenceableCollection.  Return self"

	^ self! !

Object removeSelector: #tryNamedPrimitive!
Object removeSelector: #tryNamedPrimitive:!
Object removeSelector: #tryNamedPrimitive:with:!
Object removeSelector: #tryNamedPrimitive:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:with:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:with:with:with:with:!
Object removeSelector: #tryPrimitive:withArgs:!
